import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

//Node of the tree
//Each node contains data, links to children and a flag to mark it as a leaf node
//Each node contains information about which attribute can split at the current node
public class DataNode {
	boolean isLeaf;
	List<Integer> nodeData, validAttributes;
	double entropy;
	int splittingAttribute;
	Map<String,DataNode> children;
	
	public DataNode() {
		isLeaf = false;
		nodeData = new ArrayList<>();
		validAttributes = new ArrayList<>();
		children = new HashMap<>();
		entropy = 0;
		splittingAttribute = 0;
	}
	
	public DataNode(boolean isLeaf, List<Integer> nodeData,List<Integer> validAttributes){
		this.isLeaf = isLeaf;
		this.nodeData = nodeData;
		this.children = new HashMap<>();
		this.validAttributes = validAttributes;
		this.entropy = 0;
		splittingAttribute = 0;
	}
	
	public void setNodeData(List<Integer> nodeData) {
		this.nodeData = nodeData;
	}
	
	public void setLeaf(boolean isLeaf) {
		this.isLeaf = isLeaf;
	}
	
	public void setValidAttributes(List<Integer> validAttributes) {
		this.validAttributes = validAttributes;
	}
	
	public void setEntropy(double entropy) {
		this.entropy = entropy;
	}
	
	public void setSplittingAttribute(int splittingAttribute) {
		this.splittingAttribute = splittingAttribute;
	}
	
	public List<Integer> getNodeData() {
		return nodeData;
	}
	
	public List<Integer> getValidAttributes() {
		return validAttributes;
	}
	
	public boolean isLeaf() {
		return isLeaf;
	}
	
	public double getEntropy() {
		return entropy;
	}
	
	public int getSplittingAttribute() {
		return splittingAttribute;
	}
	
	public int getNumInstances(){
		return nodeData.size();
	}
	
	public void setChildNode(String attributevalue,DataNode node){
		children.put(attributevalue, node);
	}
	
	public DataNode getChildNode(String attributeValue) {
		return children.get(attributeValue);
	}
	
}
